%global __brp_check_rpaths %{nil}
%global __requires_exclude ^libmpi
%global packname  magi
%global packver   1.2.4
%global rlibdir   /usr/local/lib/R/library

Name:             R-CRAN-%{packname}
Version:          1.2.4
Release:          1%{?dist}%{?buildtag}
Summary:          MAnifold-Constrained Gaussian Process Inference

License:          MIT + file LICENSE
URL:              https://cran.r-project.org/package=%{packname}
Source0:          %{url}&version=%{packver}#/%{packname}_%{packver}.tar.gz


BuildRequires:    R-devel >= 3.6.0
Requires:         R-core >= 3.6.0
BuildRequires:    R-CRAN-Rcpp >= 1.0.6
BuildRequires:    R-CRAN-gridExtra 
BuildRequires:    R-CRAN-gridBase 
BuildRequires:    R-grid 
BuildRequires:    R-methods 
BuildRequires:    R-CRAN-deSolve 
BuildRequires:    R-CRAN-RcppArmadillo 
BuildRequires:    R-CRAN-BH 
BuildRequires:    R-CRAN-roptim 
Requires:         R-CRAN-Rcpp >= 1.0.6
Requires:         R-CRAN-gridExtra 
Requires:         R-CRAN-gridBase 
Requires:         R-grid 
Requires:         R-methods 
Requires:         R-CRAN-deSolve 

%description
Provides fast and accurate inference for the parameter estimation problem
in Ordinary Differential Equations, including the case when there are
unobserved system components. Implements the MAGI method
(MAnifold-constrained Gaussian process Inference) of Yang, Wong, and Kou
(2021) <doi:10.1073/pnas.2020397118>. A user guide is provided by the
accompanying software paper Wong, Yang, and Kou (2024)
<doi:10.18637/jss.v109.i04>.

%prep
%setup -q -c -n %{packname}

# fix end of executable files
find -type f -executable -exec grep -Iq . {} \; -exec sed -i -e '$a\' {} \;
# prevent binary stripping
[ -d %{packname}/src ] && find %{packname}/src -type f -exec \
  sed -i 's@/usr/bin/strip@/usr/bin/true@g' {} \; || true
[ -d %{packname}/src ] && find %{packname}/src/Make* -type f -exec \
  sed -i 's@-g0@@g' {} \; || true
# don't allow local prefix in executable scripts
find -type f -executable -exec sed -Ei 's@#!( )*/usr/local/bin@#!/usr/bin@g' {} \;

%build

%install

mkdir -p %{buildroot}%{rlibdir}
%{_bindir}/R CMD INSTALL -l %{buildroot}%{rlibdir} %{packname}
test -d %{packname}/src && (cd %{packname}/src; rm -f *.o *.so)
rm -f %{buildroot}%{rlibdir}/R.css
# remove buildroot from installed files
find %{buildroot}%{rlibdir} -type f -exec sed -i "s@%{buildroot}@@g" {} \;

%files
%{rlibdir}/%{packname}
